const CodeGenerator = require('./CodeGenerator.js');

/*
 * This Visitor walks the AST generated by the transformers and produces code.
 * For every input language, can "inherit" the generated visitNode methods.
 */
class Visitor extends CodeGenerator {
  visitChildren(ctx) {
    let code = '';
    for (let i = 0; i < ctx.getChildCount(); i++) {
      code += this.visit(ctx.getChild(i));
    }
    return code.trim();
  }

  visitTerminal(ctx) {
    return ctx.getText();
  }
}

module.exports = Visitor;
